diff -uNrd -x CVS ircd-ratbox-1.4-2/doc/example.conf bcnet-ircd-1.2.2/doc/example.conf
--- ircd-ratbox-1.4-2/doc/example.conf	Wed Apr  7 16:37:42 2004
+++ bcnet-ircd-1.2.2/doc/example.conf	Sun May  9 10:35:57 2004
@@ -239,6 +239,8 @@
 	 * no_tilde      (old - flag)	| don't prefix ~ to username if no ident
 	 * need_ident    (old + flag)	| require ident for user in this class
 	 * restricted			| prevent user from sending mode changes
+     * mask					| mask the users hostname
+	 * mask_notice			| give a notice when masking this host
 	 */
 	flags = kline_exempt, exceed_limit;
 	
@@ -264,7 +266,7 @@
 	user = "*@*";
 	class = "users";
 	
-	flags = restricted, need_ident;
+	flags = restricted, need_ident, mask, mask_notice;
 };
 
 /* operator {}: defines ircd operators. (OLD O:)
diff -uNrd -x CVS ircd-ratbox-1.4-2/help/opers/cmode bcnet-ircd-1.2.2/help/opers/cmode
--- ircd-ratbox-1.4-2/help/opers/cmode	Tue Jul  8 10:12:41 2003
+++ bcnet-ircd-1.2.2/help/opers/cmode	Sun May  9 10:35:57 2004
@@ -11,6 +11,8 @@
      +m     - Moderated.  Only opped/voiced users may talk in channel.
      +i     - Invite only.  Users need to be /invite'd or match a +I to
               join the channel.
+     +c     - Strip color. The server will strip any color from channel
+              messages.
 
 WITH PARAMETERS:
      +k     - Key.  Requires users to issue /join #channel KEY to join.
diff -uNrd -x CVS ircd-ratbox-1.4-2/help/opers/index bcnet-ircd-1.2.2/help/opers/index
--- ircd-ratbox-1.4-2/help/opers/index	Mon Apr  5 15:22:44 2004
+++ bcnet-ircd-1.2.2/help/opers/index	Sun May  9 10:35:57 2004
@@ -9,14 +9,15 @@
 KILL            KLINE           KNOCK           LINKS
 LIST            LOCOPS          LUSERS          MODLIST
 MODLOAD         MODRESTART      MODUNLOAD       MOTD
-NAMES           NICK            NOTICE          OPER
-OPERSPY         OPERWALL        PART            PASS
-PING            PONG            POST            PRIVMSG
-QUIT            REHASH          RESTART         RESV
-SERVER          SET             SJOIN           SQUIT
-STATS           SVINFO          TESTLINE        TESTMASK
-TIME            TOPIC           TRACE           UHELP
-UMODE           UNDLINE         UNGLINE         UNKLINE
-UNRESV          UNXLINE         USER            USERHOST
-USERS           VERSION         WALLOPS         WHO
-WHOIS           WHOWAS          XLINE
+NAMES           NGLIST          NICK            NOTICE          
+OPER            OPERLIST        OPERSPY         OPERWALL        
+PART            PASS            PING            PONG            
+POST            PRIVMSG         QUIT            REHASH          
+RESTART         RESV            SERVER          SET  
+SJOIN           SPING           SQUIT           STATS     
+SVINFO          TESTLINE        TESTMASK        TIME     
+TOPIC           TRACE           UHELP           UMODE
+UNDLINE         UNGLINE         UNKLINE         UNRESV
+UNXLINE         USER            USERHOST        USERS
+VERSION         WALLOPS         WHO             WHOIS
+WHOWAS          XLINE
diff -uNrd -x CVS ircd-ratbox-1.4-2/help/opers/list bcnet-ircd-1.2.2/help/opers/list
--- ircd-ratbox-1.4-2/help/opers/list	Thu Apr 22 14:37:22 2004
+++ bcnet-ircd-1.2.2/help/opers/list	Sun May  9 10:35:57 2004
@@ -1,4 +1,4 @@
-LIST [#channel]|[modifiers]
+LIST [#channel]
 
 Without any arguments, LIST will give an entire list of all
 channels which are not set as secret (+s). The list will be in
@@ -6,11 +6,7 @@
 
   <#channel> <amount of users> :[topic]
 
-If an argument supplied is a channel name, LIST will give just
-the statistics for the given channel.
-
-Modifiers are also supported, seperated by a comma:
-  <n - List channels with less than n users
-  >n - List channels with more than n users
+If an argument is supplied, LIST will give just the statistics
+for the given channel.
 
-eg LIST <100,>20
+See also: join
diff -uNrd -x CVS ircd-ratbox-1.4-2/help/opers/nglist bcnet-ircd-1.2.2/help/opers/nglist
--- ircd-ratbox-1.4-2/help/opers/nglist	Wed Dec 31 19:00:00 1969
+++ bcnet-ircd-1.2.2/help/opers/nglist	Sun May  9 10:35:57 2004
@@ -0,0 +1,13 @@
+List all local or global clients that have all lower case nicks and have 
+matching nicks and gecos's (a common drone pattern)
+
+/quote NGLIST
+  List all local clients with lowercase nicks and matching nicks and gecos
+  fields.
+/quote NGLIST 10
+  List the first 10 local clients as in above.
+/quote NGLIST -g
+  List all global clients as above.
+/quote NGLIST -g 10
+  List the first 10 global clients as above.
+
diff -uNrd -x CVS ircd-ratbox-1.4-2/help/opers/operlist bcnet-ircd-1.2.2/help/opers/operlist
--- ircd-ratbox-1.4-2/help/opers/operlist	Wed Dec 31 19:00:00 1969
+++ bcnet-ircd-1.2.2/help/opers/operlist	Sun May  9 10:35:57 2004
@@ -0,0 +1,6 @@
+m_operlist.c:
+/quote OPERLIST
+  List all opers on the network
+/quote OPERLIST *.uk
+  List all opers on servers matching *.uk
+
diff -uNrd -x CVS ircd-ratbox-1.4-2/help/opers/sping bcnet-ircd-1.2.2/help/opers/sping
--- ircd-ratbox-1.4-2/help/opers/sping	Wed Dec 31 19:00:00 1969
+++ bcnet-ircd-1.2.2/help/opers/sping	Sun May  9 10:35:57 2004
@@ -0,0 +1,7 @@
+Implements an ircu like server<->server PING, must be run on each server 
+on the path to function.
+
+/quote SPING <server>
+  Send a server<->server ping to <server>, giving you a time in seconds
+  formatted X.YYY
+
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/client.h bcnet-ircd-1.2.2/include/client.h
--- ircd-ratbox-1.4-2/include/client.h	Wed Mar 24 19:30:45 2004
+++ bcnet-ircd-1.2.2/include/client.h	Sun May  9 10:35:58 2004
@@ -145,6 +145,7 @@
 	 * considered a read-only field after the client has registered.
 	 */
 	char host[HOSTLEN + 1];	/* client's hostname */
+	char rhost[HOSTLEN + 1];
 	/*
 	 * client->info for unix clients will normally contain the info from the 
 	 * gcos field in /etc/passwd but anything can go here.
@@ -378,6 +379,8 @@
 #define UMODE_ADMIN        0x40000	/* Admin on server */
 #define UMODE_HIDDENOPER   0x80000	/* Oper hidden from stats p */
 
+#define UMODE_IPMASK	   0x100000
+
 #define UMODE_ALL	   UMODE_SERVNOTICE
 
 
@@ -417,7 +420,7 @@
                          OPER_HIDDENOPER)
 
 #define SEND_UMODES  (UMODE_INVISIBLE | UMODE_OPER | UMODE_WALLOP | \
-                      UMODE_ADMIN)
+                      UMODE_ADMIN | UMODE_IPMASK)
 #define ALL_UMODES   (SEND_UMODES | UMODE_SERVNOTICE | UMODE_CCONN | \
                       UMODE_REJ | UMODE_SKILL | UMODE_FULL | UMODE_SPY | \
                       UMODE_NCHANGE | UMODE_OPERWALL | UMODE_DEBUG | \
@@ -499,6 +502,8 @@
 
 #define SetGotId(x)             ((x)->flags |= FLAGS_GOTID)
 #define IsGotId(x)              (((x)->flags & FLAGS_GOTID) != 0)
+
+#define IsMasked(x)				((x)->umodes & UMODE_IPMASK)
 
 /*
  * flags2 macros.
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/config.h bcnet-ircd-1.2.2/include/config.h
--- ircd-ratbox-1.4-2/include/config.h	Mon Mar 15 13:19:44 2004
+++ bcnet-ircd-1.2.2/include/config.h	Sun May  9 10:35:58 2004
@@ -192,7 +192,7 @@
  * If this is undefined, opers will be allowed to see the real IP of spoofed
  * users in /trace etc.  If this is defined they will be shown a masked IP.
  */
-#define HIDE_SPOOF_IPS
+#undef HIDE_SPOOF_IPS
 
 /* TS5_ONLY
  *
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/ircd_defs.h bcnet-ircd-1.2.2/include/ircd_defs.h
--- ircd-ratbox-1.4-2/include/ircd_defs.h	Mon Mar 15 13:19:44 2004
+++ bcnet-ircd-1.2.2/include/ircd_defs.h	Sun May  9 10:35:58 2004
@@ -86,9 +86,9 @@
 #define HOSTLEN         63	/* Length of hostname.  Updated to         */
 				/* comply with RFC1123                     */
 
-#define USERLEN         10
+#define USERLEN         14
 #define REALLEN         50
-#define KILLLEN         90
+#define KILLLEN         150
 #define CHANNELLEN      200
 
 #define REASONLEN	120
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/numeric.h bcnet-ircd-1.2.2/include/numeric.h
--- ircd-ratbox-1.4-2/include/numeric.h	Mon Apr  5 15:22:46 2004
+++ bcnet-ircd-1.2.2/include/numeric.h	Sun May  9 10:35:58 2004
@@ -183,12 +183,15 @@
 #define RPL_ENDOFBANLIST     368
 /* rpl_endofwhowas above (369) */
 
+#define RPL_WHOWASREALHOST   370
 #define RPL_INFO             371
 #define RPL_MOTD             372
 #define RPL_INFOSTART        373
 #define RPL_ENDOFINFO        374
 #define RPL_MOTDSTART        375
 #define RPL_ENDOFMOTD        376
+
+#define RPL_WHOISHOST        378 /* -Jeremy */
 
 #define RPL_YOUREOPER        381
 #define RPL_REHASHING        382
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/patchlevel.h bcnet-ircd-1.2.2/include/patchlevel.h
--- ircd-ratbox-1.4-2/include/patchlevel.h	Tue Apr 27 10:51:33 2004
+++ bcnet-ircd-1.2.2/include/patchlevel.h	Mon May 10 05:13:58 2004
@@ -21,9 +21,9 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: patchlevel.h,v 7.50.2.22 2004/04/27 14:51:33 androsyn Exp $
+ *  $Id: patchlevel.h,v 7.50.2.21 2004/04/10 22:38:58 leeh Exp $
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "ircd-ratbox-1.4-2"
+#define PATCHLEVEL   "ircd-ratbox-1.4-1+BCNet-1.2.2"
 #endif
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/s_conf.h bcnet-ircd-1.2.2/include/s_conf.h
--- ircd-ratbox-1.4-2/include/s_conf.h	Wed Apr  7 16:37:45 2004
+++ bcnet-ircd-1.2.2/include/s_conf.h	Sun May  9 10:35:58 2004
@@ -140,6 +140,9 @@
 #define CONF_FLAGS_CRYPTLINK            0x00400000
 #define CONF_FLAGS_VHOSTED		0x00800000
 #define CONF_FLAGS_TB			0x01000000
+
+#define CONF_FLAGS_IPMASK		0x02000000
+#define CONF_FLAGS_MASK_NOTICE	0x04000000
 /* Macros for struct ConfItem */
 
 #define IsLimitIp(x)            ((x)->flags & CONF_FLAGS_LIMIT_IP)
@@ -162,6 +165,8 @@
 #define IsConfCryptLink(x)      ((x)->flags & CONF_FLAGS_CRYPTLINK)
 #define IsConfVhosted(x)	((x)->flags & CONF_FLAGS_VHOSTED)
 #define IsConfTburst(x)		((x)->flags & CONF_FLAGS_TB)
+#define IsConfDoMaskIp(x)		((x)->flags & CONF_FLAGS_IPMASK)
+#define IsConfMaskNotice(x)		((x)->flags & CONF_FLAGS_MASK_NOTICE)
 
 /* flag definitions for opers now in client.h */
 
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/s_serv.h bcnet-ircd-1.2.2/include/s_serv.h
--- ircd-ratbox-1.4-2/include/s_serv.h	Sun Apr 11 22:08:13 2004
+++ bcnet-ircd-1.2.2/include/s_serv.h	Sun May  9 10:35:58 2004
@@ -72,12 +72,13 @@
 #define CAP_UNKLN       0x00100000	/* supports remote unkline */
 #define CAP_CLUSTER	0x00200000	/* supports clustering */
 #define CAP_ENCAP	0x00400000
+#define CAP_IPMASK  0x00800000
 
 #define CAP_MASK        (CAP_QS  | CAP_EX   | CAP_CHW  | \
                          CAP_IE  | CAP_KLN  | \
                          CAP_GLN | CAP_CLUSTER | CAP_ENCAP | \
                          CAP_ZIP  | CAP_ENC | \
-                         CAP_KNOCK  | CAP_UNKLN)
+                         CAP_KNOCK  | CAP_UNKLN | CAP_IPMASK)
 
 #ifdef HAVE_LIBZ
 #define CAP_ZIP_SUPPORTED       CAP_ZIP
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/s_user.h bcnet-ircd-1.2.2/include/s_user.h
--- ircd-ratbox-1.4-2/include/s_user.h	Sun Mar 28 06:45:14 2004
+++ bcnet-ircd-1.2.2/include/s_user.h	Sun May  9 10:35:58 2004
@@ -44,7 +44,7 @@
 extern int do_local_user(char *, struct Client *, struct Client *, char *, char *, char *, char *);
 
 extern int do_remote_user(char *, struct Client *, struct Client *,
-			  char *, char *, char *, char *);
+			  char *, char *, char *, char *, char *);
 
 extern int user_modes_from_c_to_bitmask[];
 extern void show_isupport(struct Client *);
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/serno.h bcnet-ircd-1.2.2/include/serno.h
--- ircd-ratbox-1.4-2/include/serno.h	Mon Apr 26 13:55:08 2004
+++ bcnet-ircd-1.2.2/include/serno.h	Sun May  9 10:35:58 2004
@@ -1 +1 @@
-#define SERIALNUM "20040426_1"
+#define SERIALNUM "20040421_3"
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/supported.h bcnet-ircd-1.2.2/include/supported.h
--- ircd-ratbox-1.4-2/include/supported.h	Wed Apr 21 11:07:13 2004
+++ bcnet-ircd-1.2.2/include/supported.h	Sun May  9 10:35:58 2004
@@ -65,7 +65,8 @@
 		  " ETRACE" \
 		  " WALLCHOPS" \
 		  " SAFELIST" \
-		  " ELIST=U"
+                  " ELIST=U" \
+		  " IPMASK"
 
 #define FEATURES2VALUES ConfigServerHide.disable_local_channels ? "#" : "#&", \
                         ConfigChannel.use_except ? "e" : "", \
diff -uNrd -x CVS ircd-ratbox-1.4-2/include/whowas.h bcnet-ircd-1.2.2/include/whowas.h
--- ircd-ratbox-1.4-2/include/whowas.h	Mon Mar 15 13:19:45 2004
+++ bcnet-ircd-1.2.2/include/whowas.h	Sun May  9 10:35:58 2004
@@ -51,6 +51,7 @@
 	char name[NICKLEN];
 	char username[USERLEN + 1];
 	char hostname[HOSTLEN + 1];
+	char rhostname[HOSTLEN + 1];
 	const char *servername;
 	char realname[REALLEN + 1];
 	time_t logoff;
diff -uNrd -x CVS ircd-ratbox-1.4-2/modules/core/m_nick.c bcnet-ircd-1.2.2/modules/core/m_nick.c
--- ircd-ratbox-1.4-2/modules/core/m_nick.c	Wed Mar 24 19:30:52 2004
+++ bcnet-ircd-1.2.2/modules/core/m_nick.c	Sun May  9 10:35:58 2004
@@ -277,7 +277,7 @@
 	}
 
 	/* parc == 3 on nickchange, parc == 9 on new nick */
-	if((IsClient(source_p) && (parc != 3)) || (IsServer(source_p) && (parc != 9)))
+	if((IsClient(source_p) && (parc != 3)) || (IsServer(source_p) && ((parc != 9) && (parc != 10))))
 	{
 		char tbuf[BUFSIZE] = { 0 };
 		int j;
@@ -302,23 +302,30 @@
 	/* fix the length of the nick */
 	strlcpy(nick, parv[1], sizeof(nick));
 
-	if(check_clean_nick(client_p, source_p, nick, parv[1], 
-			    (parc == 9 ? parv[7] : (char *)source_p->user->server)))
-		return;
+    if ((parc == 9) || (parc == 10))
+	{
+		if (check_clean_nick(client_p, source_p, nick, parv[1], parv[7]))
+			return;
+	}
+	else
+	{
+		if (check_clean_nick(client_p, source_p, nick, parv[1], (char *)source_p->user->server))
+			return;
+	}
 
-	if(parc == 9)
+	if(parc == 9 || parc == 10)
 	{
 		if(check_clean_user(client_p, nick, parv[5], parv[7]) ||
 		   check_clean_host(client_p, nick, parv[6], parv[7]))
 			return;
 
 		/* check the length of the clients gecos */
-		if(strlen(parv[8]) > REALLEN)
+		if(strlen(parv[(parc > 9)? 9 : 8]) > REALLEN)
 		{
 			sendto_realops_flags(UMODE_ALL, L_ALL,
 					     "Long realname from server %s for %s", parv[7],
 					     parv[1]);
-			parv[8][REALLEN] = '\0';
+			parv[(parc > 9)? 9 : 8][REALLEN] = '\0';
 		}
 
 		if(IsServer(source_p))
@@ -591,7 +598,8 @@
 			}
 
 			return do_remote_user(nick, client_p, source_p, parv[5], parv[6],
-					      parv[7], parv[8]);
+					      parv[7], (parc > 9)? parv[8] : NULL,
+						parv[(parc > 9)? 9 : 8]);
 		}
 	}
 	else if(source_p->name[0])
diff -uNrd -x CVS ircd-ratbox-1.4-2/modules/m_nglist.c bcnet-ircd-1.2.2/modules/m_nglist.c
--- ircd-ratbox-1.4-2/modules/m_nglist.c	Wed Dec 31 19:00:00 1969
+++ bcnet-ircd-1.2.2/modules/m_nglist.c	Sun May  9 10:35:58 2004
@@ -0,0 +1,196 @@
+/*
+ *  m_nglist.c: Sentinel-like nick == gecos searching functionality.
+ *
+ *  Copyright 2003 by W. Campbell
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer. 
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution. 
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission. 
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  $Id$
+ *
+ * Revision 1:  NGLIST, local and global
+ */
+
+/* List of ircd includes from ../include/ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"     /* FALSE bleah */
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void mo_nglist(struct Client *client_p, struct Client *source_p,
+                     int parc, char *parv[]);
+static int strislower(char *);
+
+struct Message nglist_msgtab = {
+  "NGLIST", 0, 0, 0, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_not_oper, m_ignore, mo_nglist}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&nglist_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&nglist_msgtab);
+}
+
+const char *_version = "$Revision$";
+#endif
+
+#define UL_GLOBAL	1
+#define UL_LOCAL	2
+
+/*
+** mo_nglist
+** Syntax:  NGLIST [-l|-g] [limit]
+** Defaults:  local scope, limit to 0 (XXX - ratbox add default confitem)
+*/
+static void mo_nglist(struct Client *client_p, struct Client *source_p,
+                     int parc, char *parv[])
+{
+  int lim = 0;
+  int count = 0;
+  struct Client *target_p;
+  char *nickname;
+  int scope_flag = UL_LOCAL;
+  int got_scope = FALSE;
+  dlink_node *dl;
+
+  if (parc > 1)
+  {
+    if (parv[1][0] == '-')
+    {
+      got_scope = TRUE;
+      if (parv[1][1] == 'g')
+        scope_flag = UL_GLOBAL;
+      /* Otherwise, default to local */
+    }
+  }
+
+  if (got_scope == TRUE)
+  {
+    if (parc > 2)
+    {
+      lim = strtol(parv[2], NULL, 10);
+    }
+  }
+  else
+  {
+    if (parc > 1)
+    {
+      lim = strtol(parv[1], NULL, 10);
+    }
+  }
+
+  if (scope_flag == UL_GLOBAL)
+  {
+#ifdef CONFIG_RATBOX_LEVEL_1
+    DLINK_FOREACH(dl, global_client_list.head)
+    {
+      target_p = dl->data;
+#elif defined(CONFIG_H_LEVEL_7)
+    for (target_p = GlobalClientList; target_p; target_p = target_p->next)
+    {
+#endif
+      if (!IsPerson(target_p))
+        continue;
+      if ((lim > 0) && (count == lim))
+      {
+        sendto_one(source_p, ":%s NOTICE %s :NGLIST limit reached, %d clients "
+                   "shown", me.name, parv[0], count);
+        return;
+      }
+      if (strislower(target_p->name) &&
+          (irccmp(target_p->info, target_p->name) == 0))
+      {
+        /* XXX - should probably use a numeric here, RPL_WHO maybe? */
+        count++;
+        sendto_one(source_p, ":%s NOTICE %s :User %d: %s (%s@%s) [%s]",
+                   me.name, parv[0], count, target_p->name,
+                   target_p->username, target_p->host,
+                   target_p->user->server);
+      }
+    }
+  }
+  else
+  {
+    /* Local clients only */
+    DLINK_FOREACH(dl, lclient_list.head)
+    {
+      target_p = dl->data;
+
+      if ((lim > 0) && (count == lim))
+      {
+        sendto_one(source_p, ":%s NOTICE %s :NGLIST limit reached, %d clients "
+                   "shown", me.name, parv[0], count);
+        return;
+      }
+      if (strislower(target_p->name) &&
+          (irccmp(target_p->info, target_p->name) == 0))
+      {
+        /* XXX - should probably use a numeric here, RPL_WHO maybe? */
+        count++;
+        sendto_one(source_p, ":%s NOTICE %s :User %d: %s (%s@%s) [%s]",
+                   me.name, parv[0], count, target_p->name,
+                   target_p->username, target_p->host,
+                   target_p->user->server);
+      }
+    }
+  }
+  sendto_one(source_p, ":%s NOTICE %s :End of NGLIST.", me.name, parv[0]);
+}
+
+/* Return 1 if the string s is all lower case, return 0 if not */
+static int strislower(char *s)
+{
+  char *t;
+
+  if (s == NULL)
+    return 1;
+  for (t = s; *t != '\0'; t++)
+  {
+    if (islower((int) *t) == 0)
+    {
+      return 0;
+    }
+  }
+  return 1;
+}
diff -uNrd -x CVS ircd-ratbox-1.4-2/modules/m_operlist.c bcnet-ircd-1.2.2/modules/m_operlist.c
--- ircd-ratbox-1.4-2/modules/m_operlist.c	Wed Dec 31 19:00:00 1969
+++ bcnet-ircd-1.2.2/modules/m_operlist.c	Sun May  9 10:35:58 2004
@@ -0,0 +1,125 @@
+/*
+ *  m_operlist.c: List all (global) opers on the network or on a servermask
+ *                provided.
+ *
+ *  Copyright 2003 by W. Campbell
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer. 
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution. 
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission. 
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  $Id$
+ *
+ */
+
+/* List of ircd includes from ../include/ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"     /* FALSE bleah */
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "s_misc.h"
+
+static void mo_operlist(struct Client *client_p, struct Client *source_p,
+                     int parc, char *parv[]);
+
+struct Message operlist_msgtab = {
+  "OPERLIST", 0, 0, 0, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_not_oper, m_ignore, mo_operlist}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&operlist_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&operlist_msgtab);
+}
+
+const char *_version = "$Revision$";
+#endif
+
+/*
+** mo_operlist
+** Syntax:  OPERLIST [servermask]
+** Default:  all servers
+*/
+static void mo_operlist(struct Client *client_p, struct Client *source_p,
+                        int parc, char *parv[])
+{		 
+  int count = 0;
+  struct Client *target_p;
+  dlink_node *dl;
+  char *smatch = NULL;
+
+  if (parc > 1)
+  {
+    smatch = parv[1];
+  }
+
+#ifdef CONFIG_RATBOX_LEVEL_1
+  DLINK_FOREACH(dl, global_client_list.head)
+  {
+    target_p = dl->data;
+#elif defined(CONFIG_H_LEVEL_7)
+  for (target_p = GlobalClientList; target_p; target_p = target_p->next)
+  {
+#endif
+    if (IsOper(target_p))
+    {
+      if (smatch != NULL)
+      {
+        if (match(smatch, target_p->user->server) == 0)
+        {
+          /* Not matched, the oper is not on the requested server */
+          continue;
+        }
+      }
+      sendto_one(source_p, ":%s %d %s p :[%c] %s (%s@%s) on %s",
+                 me.name, RPL_STATSDEBUG, source_p->name,
+                 IsAdmin(target_p) ? 'A' : 'O',
+                 target_p->name, target_p->username, target_p->host,
+                 target_p->user->server);
+      count++;
+    }
+  }
+  sendto_one(source_p, ":%s %d %s p :%d OPER(s)", me.name, RPL_STATSDEBUG,
+             source_p->name, count);
+}
+
diff -uNrd -x CVS ircd-ratbox-1.4-2/modules/m_sping.c bcnet-ircd-1.2.2/modules/m_sping.c
--- ircd-ratbox-1.4-2/modules/m_sping.c	Wed Dec 31 19:00:00 1969
+++ bcnet-ircd-1.2.2/modules/m_sping.c	Sun May  9 10:35:58 2004
@@ -0,0 +1,160 @@
+/*
+ *  m_sping.c: Implements timed server-server pinging
+ *
+ *  Copyright 2003 by W. Campbell
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  $Id$
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"     /* FALSE bleah */
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void ms_sping(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+static void mo_sping(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+static void ms_spong(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+struct Message sping_msgtab = {
+  "SPING", 0, 0, 2, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_not_oper, ms_sping, mo_sping}
+};
+
+struct Message spong_msgtab = {
+  "SPONG", 0, 0, 5, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_ignore, ms_spong, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&sping_msgtab);
+  mod_add_cmd(&spong_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&sping_msgtab);
+  mod_del_cmd(&spong_msgtab);
+}
+
+const char *_version = "$Revision$";
+#endif
+
+static void ms_sping(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  if (hunt_server(client_p, source_p, ":%s SPING %s %s %s %s",
+                  1, parc, parv) == HUNTED_ISME)
+  {
+    sendto_one(source_p, ":%s SPONG %s %s %s %s", me.name, parv[0],
+               parv[2], parv[3], parv[4]);
+  }
+}
+
+static void ms_spong(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  struct timeval nowtv;
+  struct timeval prevtv;
+  struct Client *target_p;
+  double tdiff;
+
+  if (hunt_server(client_p, source_p, ":%s SPONG %s %s %s %s",
+                  1, parc, parv) == HUNTED_ISME)
+  {
+    /* Get the current time first, in order to prevent computational time
+    ** from being counted against a server
+    */
+    gettimeofday(&nowtv, NULL);
+    prevtv.tv_sec = strtol(parv[3], NULL, 10);
+    prevtv.tv_usec = strtol(parv[4], NULL, 10);
+
+    if (nowtv.tv_sec > prevtv.tv_sec)
+    {
+      nowtv.tv_usec += 1000000; /* Yes this is lame, manually do a subtraction
+                                ** carry
+                                */
+      nowtv.tv_sec--;
+    }
+
+    /* Assume that tv_usec in nowtv is always greater than prevtv's */
+    target_p = find_person(parv[2]);
+    if (target_p == NULL)
+      return;
+    tdiff = (nowtv.tv_sec - prevtv.tv_sec) +
+            ((nowtv.tv_usec - prevtv.tv_usec) / 1000000.0);
+    sendto_one(target_p, ":%s NOTICE %s :SPONG from %s:  %1.3f seconds",
+               me.name, target_p->name, source_p->name, tdiff);
+  }
+}
+
+static void mo_sping(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  struct timeval nowtv;
+  char *argv[6];
+  int argc;
+  char secbuf[12];
+  char usecbuf[8];
+
+  gettimeofday(&nowtv, NULL);
+
+  /* Syntax:  :sourceserver SPING destserver user tv_sec tv_usec */
+  argv[0] = me.name;
+  argv[1] = parv[1];
+  argv[2] = parv[0];
+  snprintf(secbuf, 12, "%ld", nowtv.tv_sec);
+  argv[3] = secbuf;
+  snprintf(usecbuf, 8, "%ld", nowtv.tv_usec);
+  argv[4] = usecbuf;
+  argc = 5;
+
+  if (hunt_server(client_p, source_p, ":%s SPING %s %s %s %s",
+                  1, argc, argv) == HUNTED_ISME)
+  {
+    sendto_one(source_p, ":%s NOTICE %s :Cannot SPING myself!", me.name,
+               parv[0]);
+  }
+}
